var urlInfo = utils.parseUrl(window.location.href);
window.myEditor = new IthomeEditor("myEditor", function (data, callback) {
    rm && rm.isLegalEnv() && rm.ready(function () {
        if (data.name === "_editor_ready") {

            document.getElementsByTagName("body")[0].classList.add(rm.getEnv().platform);

            // 原生调用编辑器JS API，获取回调
            // data格式: {func: "insertHtml", args: ["hhh", [1,2]]}
            rm.onReceiveMessage("invokeEditorMethod", function (data, callback) {
                if (data.func === "presubmit") {
                    // 客户端准备提交数据，编辑器做最后的校验处理
                    // arg格式: {quanId: 27, categoryId: 22}
                    var arg = data.args && data.args[0];
                    // 1、源码模式下无法获取到最新的HTML，需要切换到正常模式
                    if (myEditor.isSourceMode()) {
                        myEditor.source()
                    }
                    console.log("arg", arg)
                    var success = true;
                    var message = "校验成功";
                    var html = myEditor.getHtml();
                    // 2、二手交易圈必须添加咸鱼链接。交由服务器端处理
                    // if (urlInfo.params.mode === "post"
                    //     && arg && arg.quanId === 55 && arg.categoryId !== 7) {
                    //     if (html.indexOf("market.m.taobao.com") === -1) {
                    //         success = false;
                    //         message = "请添加咸鱼宝贝/收二手地址";
                    //     }
                    // }
                    // 3、将base64表情替换成最终提交的字符串
                    var needProcessEmotion = rm.getEnv().platform === "iOS" && rm.getEnv().appver === 7.33;
                    if (needProcessEmotion) {
                        var domTemp = document.createElement("div");
                        domTemp.innerHTML = html;
                        var imgs = domUtils.getElementsByTagName(domTemp, "img");
                        for (var i = 0; i < imgs.length; i++) {
                            var src = imgs[i].getAttribute("src");
                            var alt = imgs[i].getAttribute("alt");
                            var clzz = imgs[i].getAttribute("class");
                            if (alt
                                && alt.indexOf("[") === 0
                                && alt.indexOf("]") === alt.length - 1
                                && (clzz === "ruanmei-emotion" || src.indexOf("data:image/png;base64") === 0)) {
                                imgs[i].insertAdjacentHTML('afterend', alt);
                                UM.dom.domUtils.remove(imgs[i]);
                            }
                        }
                        html = domTemp.innerHTML;
                        domTemp = null;
                        console.log("最终html", html)
                    }

                    setTimeout(function () {
                        callback && callback({
                            result: {
                                success: success,
                                message: message,
                                html: html,
                            }
                        });
                    }, 50)
                } else {
                    // 调用其他编辑器方法
                    var res = myEditor[data.func].apply(myEditor, data.args);
                    callback && callback({ result: res });
                    if (data.func === "focus" && rm.getEnv().platform === "Android") {
                        rm.openKeyboard("myEditor");
                    }
                    if (data.func === "setHtml") {
                        utils.parseWeiboVideo();
                    }
                }
            })

            // 原生通知编辑器当前选择的圈子和分类有变化
            // data格式: {quanId: 27, categoryId: 22}
            rm.onReceiveMessage("quanCategoryChanged", function (data) {
                if (rm.getUserInfoSync().success) {
                    var userInfo = rm.getUserInfoSync().userInfo;
                    if (userInfo.isc === "true") {
                        // rm.toast({ data: JSON.stringify(data) })
                    }
                }
            })

            //////////////////////////////////////
            /// 扩展方法编辑器，这些方法使用了JSSDK ///
            //////////////////////////////////////

            // 插入视频
            myEditor.insertVideo = function (text) {
                rm.showLoading({ title: "正在解析链接..." })
                utils.getVideoHtmlForText(text, function (res) {
                    setTimeout(function () {
                        console.log("视频解析结果", res)
                        rm.hideLoading();
                        var resHtml = res.html;
                        if (!!resHtml) {
                            myEditor.inserHtml("<p contenteditable='false' class='"
                                + (res.plat === "yunyinyue" ? "ithome-music" : "ithome-video " + res.plat)
                                + "'>" + resHtml + "</p>");
                        } else {
                            rm.toast({ data: "不支持的视频地址" })
                        }
                        // iOS端需要获取下焦点, 理论上不影响其他平台
                        myEditor.focus();
                    }, 1200)
                })
            }
        }
        rm.sendMessage(data, callback);
    })
});